package org.coderu.common.utils;

public final class ExceptionWrapper {

    public interface IFunctor<T> {
        T execute() throws Exception;
    }

    /**
     * transforms exception to runtime exception
     */
    public static <T> T execute(final IFunctor<T> functor) {
        try {
            return functor.execute();
        }
        catch (final Exception ex) {
            if (ex instanceof RuntimeException) {
                throw (RuntimeException) ex;
            } else {
                throw new RuntimeException(ex.getMessage(), ex);
            }
        }
    }

    private ExceptionWrapper() {
    }

}