package org.coderu.core.impl.common.types;

import static org.coderu.common.utils.CollectionUtils.*;

import java.util.Collection;

import org.coderu.common.utils.PairUtils;
import org.coderu.common.utils.types.AbstractPair;
import org.coderu.common.utils.types.Pair;
import org.coderu.core.api.Clazz;

import com.google.common.base.Function;


@SuppressWarnings("serial")
public final class ClassDependencies extends AbstractPair<Clazz,Collection<Clazz>>{

    public static final Function<ClassDependencies,Clazz> TO_CLAZZ = 
        new Function<ClassDependencies, Clazz>() {
        
        public Clazz apply(ClassDependencies o) {
            return o.getFirst();
        }
    };
    
    public static final Function<ClassDependencies, Collection<Clazz>> TO_DEPENDENCIES = 
        new Function<ClassDependencies, Collection<Clazz>>() {
        
        public Collection<Clazz> apply(ClassDependencies o) {
        
            return o.getSecond();
        }
    }; 
    
    public static final Function<ClassDependencies, Collection<Pair<Clazz,Clazz>>> EXPAND = 
        new Function<ClassDependencies, Collection<Pair<Clazz,Clazz>>>() {
            
            public Collection<Pair<Clazz, Clazz>> apply(ClassDependencies o) {
            
                final Function<Clazz, Pair<Clazz, Clazz>> bindLeft = 
                    PairUtils.<Clazz,Clazz>bindLeft(o.getFirst());
                
                return transform(o.getSecond(), bindLeft);
            }
        };
    
    public ClassDependencies(Clazz first, Collection<Clazz> second) {
        super(first, second);
    }
    
}