package org.coderu.core.impl.common.types;

import org.coderu.common.utils.types.SingleValue;

import com.google.common.base.Function;


@SuppressWarnings("serial")
public final class PackageType extends SingleValue<String>{
    
    public static final Function<PackageType,String> TO_VALUE = new Function<PackageType, String>() {
        
        public String apply(PackageType o) {
            return o.getValue();
        }
    };
    
    public static final PackageType FACTORY = new PackageType("factory");
    public static final PackageType IMPL  = new PackageType("impl");
    public static final PackageType COMMON = new PackageType("common");
    public static final PackageType API = new PackageType("api");
    
    private PackageType(final String name) {
        super(name);
    }
    
    public String getName() {

        return super.getValue();
    }

}