package org.coderu.core.impl.common.types;

import java.util.Collection;
import java.util.LinkedList;

import org.coderu.common.utils.types.AbstractTriple;
import org.coderu.core.api.Packagge;

import com.google.common.base.Function;


public final class PackageWithDependencies 
extends AbstractTriple<Packagge,Collection<ClassDependencies>, Collection<PackageWithDependencies>> {

    public static final Function<PackageWithDependencies,Packagge> TO_PACKAGE = 
        new Function<PackageWithDependencies, Packagge>() {
        
        public Packagge apply(PackageWithDependencies o) {
        
            return o.getFirst();
        }
    };

    public static final Function<PackageWithDependencies,Collection<ClassDependencies>> TO_CLASS_DEPENDENCIES = 
        new Function<PackageWithDependencies, Collection<ClassDependencies>>() {
            
            @Override
            public Collection<ClassDependencies> apply(PackageWithDependencies o) {
            
                return o.getSecond();
            }
        };
        
    public PackageWithDependencies(
        final Packagge name, 
        final Collection<ClassDependencies> classes) {

        super(name, classes, new LinkedList<PackageWithDependencies>());
    }

    public void addDependencies(final Collection<PackageWithDependencies> dependsOn){
        getThird().addAll(dependsOn);
    }
}
